searchData={"items":[{"type":"behaviour","title":"gc_discover","doc":"Behaviour to implement to build a method for discovery nodes to connect to.","ref":"gc_discover.html"},{"type":"callback","title":"gc_discover.init/1","doc":"Called only when a `gen_cluster` first starts or restarts.","ref":"gc_discover.html#c:init/1"},{"type":"callback","title":"gc_discover.peers/1","doc":"Returns the peer nodes for `gen_cluster` to call `connect` on.","ref":"gc_discover.html#c:peers/1"},{"type":"type","title":"gc_discover.cb_state/0","doc":"The state of the callback.","ref":"gc_discover.html#t:cb_state/0"},{"type":"module","title":"gc_discover_dns","doc":"Utility functions for working with DNS related types and options.","ref":"gc_discover_dns.html"},{"type":"function","title":"gc_discover_dns.ip_record_type/1","doc":"Returns `a` when `use_ipv6` is `false` and `aaaa` when it is `true`","ref":"gc_discover_dns.html#ip_record_type/1"},{"type":"type","title":"gc_discover_dns.dns_name/0","doc":"A doman name. A string with no adjacent dots. Defined until inet_res:dns_name() is exported.","ref":"gc_discover_dns.html#t:dns_name/0"},{"type":"type","title":"gc_discover_dns.host_type/0","doc":"Whether the host part of a node name is a hostname, IPv4 or IPv6 address","ref":"gc_discover_dns.html#t:host_type/0"},{"type":"type","title":"gc_discover_dns.ip_record_type/0","doc":"Type of IP record to query DNS for, `a` or `aaaa`","ref":"gc_discover_dns.html#t:ip_record_type/0"},{"type":"type","title":"gc_discover_dns.use_ipv6/0","doc":"Whether to query for `a` or `aaaa` records","ref":"gc_discover_dns.html#t:use_ipv6/0"},{"type":"module","title":"gc_discover_dns_ip","doc":"Discovery method that takes a host name to query DNS A records for and\nuses all the returned hosts as peers to connect or reconnect to. Whether\nto use the IP or the hostname associated with each IP result is configured with\nthe option `host_type` which takes `ip` or `hostname` as values. The default\nis `ip` which uses the IP as is in the node name. When it\nis `hostname` each returned IP is passed to `inet_res:gethostbyaddr/1`\nto get a hostname for the address.\n\nSince this is a built-in discovery module it has an alias, `dns`, which\ncan be used in place of the full module name, `gc_discovery_dns_ip`. The\nalias `dns` covers both `gc_discover_dns_ip` and `gc_discover_dns_srv`.\nThis method (`gc_discover_dns_ip`) is used by default and when the option\n`record_type => ip` is given.\n\nThe name part of the node name to connect to is taken from the current node's name.\n\nThe following is an example relying on the alias, `dns`, and that `record_type`\ndefaults to `ip`:\n\n```\n{gen_cluster, [{discovery, {dns, #{domain => \"k8s-erlang-cluster.k8s-erlang-cluster\"}}}]}\n```\n\nThis results in the A records for `k8s-erlang-cluster.k8s-erlang-cluster`\nbeing queried for on every `gen_cluster` refresh interval and it tries to\nestablish connections to those not already connected to.\n\nTo use IPv6 set `ipv6` to `true`:\n\n```\n{gen_cluster, [{discovery, {dns, #{domain => \"k8s-erlang-cluster.k8s-erlang-cluster\",\n                                   ipv6 => true}}}]}\n```\n\nThis results in the AAAA records of `k8s-erlang-cluster.k8s-erlang-cluster`\nbeing queried for.","ref":"gc_discover_dns_ip.html"},{"type":"function","title":"gc_discover_dns_ip.init/1","doc":"","ref":"gc_discover_dns_ip.html#init/1"},{"type":"function","title":"gc_discover_dns_ip.peers/1","doc":"","ref":"gc_discover_dns_ip.html#peers/1"},{"type":"type","title":"gc_discover_dns_ip.options/0","doc":"Module options. Takes a domain to query for, an optional `host_type` which\ncan be `ip` or `hostname`, a boolean `ipv6` for whether to query for `A` or\n`AAAA` records and `lookup_timeout` which is the time each DNS query can take.","ref":"gc_discover_dns_ip.html#t:options/0"},{"type":"module","title":"gc_discover_dns_srv","doc":"Discovery method that takes a host name to query DNS SRV records for and\nuses all the returned hosts as peers to connect or reconnect to. Whether\nto use the hostname or IP for each hostname result is configured with\nthe option `host_type` which takes `hostname` or `ip` as values. The default\nis `hostname` which keeps the result as is in the node name. When it\nis `ip` each returned hostname is passed to `inet_res:getbyname/3`\nto get an IP.\n\nSince this is a built-in discovery module it has an alias, `dns`, which\ncan be used in place of the full module name, `gc_discovery_dns_srv`. The\nalias `dns` covers both `gc_discover_dns_ip` and `gc_discover_dns_srv`.\nThis module (`gc_discover_dns_srv`) is used when the option\n`record_type => srv` is given.\n\nThe name part of the node name to connect to is taken from the current node's name.\n\nThe following is an example relying on the alias, `dns`:\n\n```\n{gen_cluster, [{discovery, {dns, #{record_type => srv,\n                                   domain => \"k8s-erlang-cluster.k8s-erlang-cluster\"}}}]}\n```\n\nThis results in the SRV records for `k8s-erlang-cluster.k8s-erlang-cluster`\nbeing queried for every `gen_cluster` refresh interval and it tries to\nestablish connections to those not already connected to.\n\nTo use IPv6 addresses as the host part of each node name set both\n`host_type` to `ip` and `ipv6` to `true`:\n\n```\n{gen_cluster, [{discovery, {dns, #{record_type => srv,\n                                   domain => \"k8s-erlang-cluster.k8s-erlang-cluster\",\n                                   host_type => ip,\n                                   ipv6 => true}}}]}\n```","ref":"gc_discover_dns_srv.html"},{"type":"function","title":"gc_discover_dns_srv.init/1","doc":"","ref":"gc_discover_dns_srv.html#init/1"},{"type":"function","title":"gc_discover_dns_srv.peers/1","doc":"","ref":"gc_discover_dns_srv.html#peers/1"},{"type":"type","title":"gc_discover_dns_srv.options/0","doc":"Module options. Takes `domain`, the domain to query for, an optional `host_type` which\ncan be `ip` or `hostname`, the optional boolean `ipv6` for whether to query for `A` or\n`AAAA` record when `host_type` is `ip` and optional `lookup_timeout` which is the time\neach DNS query can take (defaults to 5000 milliseconds).","ref":"gc_discover_dns_srv.html#t:options/0"},{"type":"module","title":"gc_discover_epmd_all","doc":"Implementation of `gc_discover` that connects to all nodes found on the same epmd\nas the one this node is connected to that also has the configured `host`.  The\n`host` defaults to the hostname of the current node's node name if no `hosts` key is\ngiven in the options for this module.","ref":"gc_discover_epmd_all.html"},{"type":"module","title":"Configuration examples - gc_discover_epmd_all","doc":"Using the application environment (these config list could also be passed in as\nan argument to `gen_cluster:start_link()`)\n\n    {gen_cluster, [{discover, {epmd_all, #{}}}]}\n\n    {gen_cluster, [{discover, {epmd_all, #{hosts => [rosa]}}}]}","ref":"gc_discover_epmd_all.html#module-configuration-examples"},{"type":"function","title":"gc_discover_epmd_all.init/1","doc":"","ref":"gc_discover_epmd_all.html#init/1"},{"type":"function","title":"gc_discover_epmd_all.peers/1","doc":"","ref":"gc_discover_epmd_all.html#peers/1"},{"type":"type","title":"gc_discover_epmd_all.host/0","doc":"Name of the host to look for nodes on through epmd","ref":"gc_discover_epmd_all.html#t:host/0"},{"type":"type","title":"gc_discover_epmd_all.options/0","doc":"Options map to pass configuration for this discover module. Takes an\noption ``hosts`` key with a list of hosts to check for nodes on from the\nepmd. If `hosts` is not set in the configuration then the only host\nchecked for through `epmd` is the host of the current node's node name.","ref":"gc_discover_epmd_all.html#t:options/0"},{"type":"module","title":"gc_discover_static","doc":"Discovery method that takes a list of hosts to connect to and to\nreconnect to if a connect is lost. Reconnection can be disabled by\nincluding the option `refresh_interval_ms => infinity` when starting\n`gen_cluster`.\n\nThis is a built-in discover implementation so has a short name,\n`static`, as well.","ref":"gc_discover_static.html"},{"type":"function","title":"gc_discover_static.init/1","doc":"","ref":"gc_discover_static.html#init/1"},{"type":"function","title":"gc_discover_static.peers/1","doc":"","ref":"gc_discover_static.html#peers/1"},{"type":"type","title":"gc_discover_static.options/0","doc":"The options for starting this discover module, a list of node names","ref":"gc_discover_static.html#t:options/0"},{"type":"behaviour","title":"gc_dist","doc":"Behaviour to implement to build a new method for connecting nodes into a\ncluster.","ref":"gc_dist.html"},{"type":"callback","title":"gc_dist.connect/2","doc":"Connect the current node to the argument peer.","ref":"gc_dist.html#c:connect/2"},{"type":"callback","title":"gc_dist.disconnect/2","doc":"Disconnect the peer from the current node.","ref":"gc_dist.html#c:disconnect/2"},{"type":"callback","title":"gc_dist.init/1","doc":"Called only when a `gen_cluster` first starts or restarts.","ref":"gc_dist.html#c:init/1"},{"type":"callback","title":"gc_dist.members/1","doc":"Return the current members connected in the cluster.","ref":"gc_dist.html#c:members/1"},{"type":"type","title":"gc_dist.cb_state/0","doc":"The state of the callback.","ref":"gc_dist.html#t:cb_state/0"},{"type":"module","title":"gc_dist_erl","doc":"The default implementation of `gc_dist` that uses Erlang distribution for\nreturning the current peers (nodes), connecting to a peer (node) or\ndisconnecting from a peer (node).","ref":"gc_dist_erl.html"},{"type":"function","title":"gc_dist_erl.connect/2","doc":"","ref":"gc_dist_erl.html#connect/2"},{"type":"function","title":"gc_dist_erl.disconnect/2","doc":"","ref":"gc_dist_erl.html#disconnect/2"},{"type":"function","title":"gc_dist_erl.init/1","doc":"","ref":"gc_dist_erl.html#init/1"},{"type":"function","title":"gc_dist_erl.members/1","doc":"","ref":"gc_dist_erl.html#members/1"},{"type":"module","title":"gen_cluster","doc":"Process that manages calling the necessary discovery and connect/disconnect\nfunctions at a configurable interval.","ref":"gen_cluster.html"},{"type":"function","title":"gen_cluster.active/3","doc":"","ref":"gen_cluster.html#active/3"},{"type":"function","title":"gen_cluster.callback_mode/0","doc":"","ref":"gen_cluster.html#callback_mode/0"},{"type":"function","title":"gen_cluster.code_change/4","doc":"","ref":"gen_cluster.html#code_change/4"},{"type":"function","title":"gen_cluster.inactive/3","doc":"","ref":"gen_cluster.html#inactive/3"},{"type":"function","title":"gen_cluster.init/1","doc":"","ref":"gen_cluster.html#init/1"},{"type":"function","title":"gen_cluster.nodes_to_peers/1","doc":"","ref":"gen_cluster.html#nodes_to_peers/1"},{"type":"function","title":"gen_cluster.start_link/1","doc":"","ref":"gen_cluster.html#start_link/1"},{"type":"function","title":"gen_cluster.terminate/3","doc":"","ref":"gen_cluster.html#terminate/3"},{"type":"type","title":"gen_cluster.builtin_discovery/0","doc":"","ref":"gen_cluster.html#t:builtin_discovery/0"},{"type":"type","title":"gen_cluster.cb_state/0","doc":"","ref":"gen_cluster.html#t:cb_state/0"},{"type":"type","title":"gen_cluster.config/0","doc":"","ref":"gen_cluster.html#t:config/0"},{"type":"type","title":"gen_cluster.option/0","doc":"","ref":"gen_cluster.html#t:option/0"},{"type":"type","title":"gen_cluster.peer/0","doc":"","ref":"gen_cluster.html#t:peer/0"},{"type":"type","title":"gen_cluster.peers/0","doc":"","ref":"gen_cluster.html#t:peers/0"},{"type":"module","title":"gen_cluster_app","doc":"Application module which runs the top level `gen_cluster_sup` when started.","ref":"gen_cluster_app.html"},{"type":"function","title":"gen_cluster_app.start/2","doc":"","ref":"gen_cluster_app.html#start/2"},{"type":"function","title":"gen_cluster_app.stop/1","doc":"","ref":"gen_cluster_app.html#stop/1"},{"type":"module","title":"gen_cluster_sup","doc":"Top level supervisor of `gen_cluster` which starts a `gen_cluster`\nprocess if there is a non-empty `gen_cluster` application\nconfiguration.","ref":"gen_cluster_sup.html"},{"type":"function","title":"gen_cluster_sup.init/1","doc":"","ref":"gen_cluster_sup.html#init/1"},{"type":"function","title":"gen_cluster_sup.start_link/0","doc":"","ref":"gen_cluster_sup.html#start_link/0"},{"type":"extras","title":"Overview","doc":"gen_cluster\n=====\n\n[![Tests](https://github.com/tsloughter/gen_cluster/actions/workflows/ci.yml/badge.svg)](https://github.com/tsloughter/gen_cluster/actions/workflows/ci.yml)\n[![Hex.pm](https://img.shields.io/hexpm/v/gen_cluster.svg?style=flat)](https://hex.pm/packages/gen_cluster)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/gen_cluster/)\n\n`gen_cluster` is a helper library for connecting and reconnecting nodes together\nthrough implementations of the `gc_disovery` behaviour for discovering the nodes\nto connect to. `gc_dist` is a behaviour for what is needed to connect the nodes\n(for example, to use [partisan](https://github.com/lasp-lang/partisan) in place\nof built-in distribution).\n\nThis is still in very early stages of development. It is based off of past projects\nthat did the same thing but builtin and redone every time I worked on a new\nproject somewhere.\n\nThe API may (will) change! This is a first pass at a generalization.\n\n# Requirements\n\n* Erlang/OTP 27+ (I wanted to try the new docs)\n\n# Usage\n\nBy default no clustering is done when `gen_cluster` is started. If `gen_cluster`\nis started on boot of an OTP release or with\n`application:ensure_all_started(gen_cluster)` and the application environment is\n`[]` or not set at all then no `gen_cluster` process is started, only the\n`supervisor` process is started with an empty child list. Then you can instead\nstart `gen_cluster` in your own supervision tree with `gen_cluster:start_link`.\n\nIf there is configuration in the application environment then a `gen_cluster`\nprocess is started by the top level supervisor and it attempts to connect to all\nnodes returned by the configured discovery module (the default is `{static, []}`\nwhich returns no nodes) and it looks for new or disconnected nodes on an\ninterval (defaults to `5000` milliseconds).\n\nEven if started on boot additional clusters can be joined with\n`gen_cluster:start_link` (as in, with a separate distribution module than Erlang\ndistribution you could connect to an additional cluster).\n\n# Configuration","ref":"readme.html"},{"type":"extras","title":"Application Environment - Overview","doc":"","ref":"readme.html#application-environment"},{"type":"extras","title":"EPMD and Static - Overview","doc":"If configuration is given in `sys.config` for `gen_cluster` it will start on\nboot. \n\nThe simplest way to try `gen_cluster` is with `gc_discover_epmd_all` which\nwill connect to all other hosts that connect to the same `epmd`. The empty\nconfiguration is the same as `#{hosts => [localhost]}`:\n\n```erlang\n{gen_cluster, [{discovery, {epmd_all, #{}}}]}\n```\n\nor `gc_discover_static` which takes a list of nodes to connect to, for example\non my system `rosa` with 2 nodes `a` and `b` already running:\n\n```erlang\n{gen_cluster, [{discovery, {static, ['a@rosa', 'b@rosa']}}]}\n```","ref":"readme.html#epmd-and-static"},{"type":"extras","title":"DNS - Overview","doc":"To disable reconnection set `refresh_interval_ms` to `infinity`.\n\nAn example of using DNS to connect nodes is found in `examples/`, the\n`gen_cluster` configuration is in the example `k8s_erlang_cluster` is:\n\n```erlang\n{gen_cluster, [{discovery, {dns, #{domain => \"k8s-erlang-cluster.k8s-erlang-cluster\"}}}]},\n```\n\nConfigure `refresh_interval_ms` (default `5000`) to have `gen_cluster` look for\nnew, disconnected or removed nodes more or less often.\n\nCurrently a node removed will not be disconnected but if its connection goes\ndown and it is not still in the list of discovered nodes it won't attempt a\nreconnect. How this works in the future is undecided. It will likely be\nconfigurable and default to not disconnecting nodes still in the node list but\nnot in the discovery list, this is to allow for graceful shutdown in the case a\nnode is shutting down, but still completing work, and gets removed from DNS in\norder to not get new work but may still need to communicate its final results or\nhandoff.\n\nOther future configuration changes are the reconnect interval being separate\nfrom refresh with a backoff tracked per-node it is attempting to reconnected.\n\n#### IPv6\n\nSet `ipv6` to true in the configuration map to tell `gen_cluster` to use IPv6\nfor either the initial DNS query -- used when the `gc_discover_dns_ip` module is\nused -- or for turning returned domains into IP's -- used when a `SRV` query is\nused with `host_type` set to `ip` to turn the returned domains into IPs.","ref":"readme.html#dns"},{"type":"extras","title":"Starting Manually - Overview","doc":"If no configuration is given to `gen_cluster` on boot it will not start a\n`gen_cluster` process. You can start `gen_cluster` with `start_link`:\n\n```erlang\ngen_cluster:start_link([{discovery, {dns, #{domain =>\n                                           \"k8s-erlang-cluster.k8s-erlang-cluster\"}}}])\n```\n\nOr as a child in your supervision tree:\n\n```erlang\nGenClusterConfig = [{discovery, {ip, #{domain =>\n                                       \"k8s-erlang-cluster.k8s-erlang-cluster\"}}}],\n[#{id => gen_cluster,\n  start => {gen_cluster, start_link, [GenClusterConfig]}}]\n```\n\n# Using in Kubernetes\n\nSee documentation in the examples or on Hex Docs see the sidebar for the\nKubernetes section.\n\n# Implementing Third Party Discovery or Connection\n\nThere is a behaviour for both discovery (`gc_discover`) and peer connection\n(`gc_dist`) respectively. Discover must have an `init/1` for initializing and\nreturning any needed state for later returning a list of peers to be connected\nto:\n\n```erlang\n-callback init(term()) -> {ok, cb_state()}.\n-callback peers(cb_state()) -> gen_cluster:peers().\n```\n\nThe discover module must have an `init/1` for initializing and returning any\nnecessary state, the `members` callback which is for returning the current list of\nconnected peers in the cluster, and a callback for both connecting and\ndisconnecting from peers:\n\n```erlang\n-callback init(cb_state()) -> {ok, cb_state()}.\n-callback members(cb_state()) -> gen_cluster:peers().\n-callback connect(gen_cluster:peer(), cb_state()) -> boolean() | ignored.\n-callback disconnect(gen_cluster:peer(), cb_state()) -> boolean() | ignored.\n```\n\n# Testing\n\nRight now tests are all done on the DNS method of discovery and based on the\nexamples. The setup and configuration is only done in GitHub Actions so the\nquickest way to run them locally would be with [`act`](https://nektosact.com/).\n\n# Acknowledgments\n\nMore projects than I can recount that I've worked on has simply redone this\nlogic. Usually this was before K8s. Then in\n[Erleans](https://github.com/erleans/erleans) I had to do it for k8s and local\nand redid the logic again. As I start to break things out of Erleans and\nsimplify it this is one of the first parts to become its own library, but there\nis a long history before Erleans. Long ago I thought\n[Erlware](https://github.com/erlware/) had an app but I can't find it on Google\nCode, only [nodefinder](https://code.google.com/archive/p/nodefinder/) from\n[Dukes of Erl](http://dukesoferl.blogspot.com/).\n\n[nodefinder](https://github.com/okeuday/nodefinder/tree/master/src) by\n[okeuday](https://github.com/okeuday/) is a successor to the that project. It\nhas support for EC2 and multi-cast.\n\nIn [Elixir](https://elixir-lang.org/) everyone uses\n[libcluster](https://github.com/bitwalker/libcluster/).\n\nAnd in [Gleam](https://gleam.run/) the library\n[Barnacle](https://github.com/Pevensie/barnacle) is the way to go.\n\n`gen_cluster` takes inspiration from all these works.","ref":"readme.html#starting-manually"},{"type":"extras","title":"Kubernetes Examples","doc":"# Kubernetes Examples\n\nAn example showing the use of `gen_cluster` for creating an Erlang cluster in\nKubernetes with the 2 types of builtin DNS support, `A` and `SRV` records.","ref":"kubernetes_example.md.html"},{"type":"extras","title":"IPs - Kubernetes Examples","doc":"This build is done with the `rebar3` profile `ip_prod` and a separate Dockerfile\n`Dockerfile.ip`.","ref":"kubernetes_example.md.html#ips"},{"type":"extras","title":"Setup - Kubernetes Examples","doc":"Under `examples/k8s_erlang_cluster` there is an example project that builds an\nErlang release with [kustomize](https://kustomize.io/) configuration to deploy a\ncluster to Kubernetes. The example's `config/sys.config` contains configuration\nfor `gen_cluster` which is started on boot of the release:\n\n```erlang\n{discovery, {dns, #{domain => \"k8s-erlang-cluster.k8s-erlang-cluster\"}}}\n```\n\nThis tells `gen_cluster` to use the DNS module for finding peers which defaults\nto looking up `A` records and using the IPs as the host part of each node name.\nThe `domain` is set to ` . ` which resolves to records for\nthe service `k8s-erlang-cluster` in a namespace `k8s-erlang-cluster`.\n\nTo set the node name properly there are 3 pieces of configuration. First,\n`config/vm.args.src` sets `-name` to use an environment variable `POD_IP`:\n\n```shell\n-name k8s_erlang_cluster@${NODE_HOST}\n```\n\nNext, the environment of the container that runs the release is made to set the\nenvironment variable `POD_IP` to the IP address of that Pod in\n`deployment/base/deployment.yaml`:\n\n```yaml\nenv:\n- name: ERL_DIST_PORT\n  value: \"39135\"\n- name: NODE_HOST\n  valueFrom:\n    fieldRef:\n        fieldPath: status.podIP\n```\n\n> #### Note {: .info}\n>\n> `ERL_DIST_PORT` is also set in the environment. This tells the rebar3 release\n> start script to configure the VM to listen on that port number for\n> distribution connections, as well as what port to connect to other nodes\n> on.  Setting the variable will disable EPMD as it is not needed if we know the\n> port to use and the port used by all other nodes in the cluster.\n\nLastly, a [headless\nservice](https://kubernetes.io/docs/concepts/services-networking/service/#headless-services)\nis used to expose the IPs of these Pods through DNS. A headless service is\ncreated when `clusterIP` is set to `None` in the `Service` resource, found in\n`deployment/base/service.yaml`:\n\n```yaml\nclusterIP: None\nports:\n- protocol: TCP\n  port: 39135\n  targetPort: 39135\n  name: dist-erl\n```\n\nA Service without `clusterIP: None` would have a single IP to load balance\nrequests to the Pods through. The headless service results in an Endpoint\nper-Pod, see below in the steps to setup the cluster in\n[kind](https://kind.sigs.k8s.io/) for an example.","ref":"kubernetes_example.md.html#setup"},{"type":"extras","title":"Run - Kubernetes Examples","doc":"The example can be installed to any Kubernetes cluster but comes with a\nconfiguration (`examples/k8s_erlang_cluster/cluster.yaml`) for creating the\ncluster with [kind](https://kind.sigs.k8s.io/) via the tool\n[ctlptl](https://github.com/tilt-dev/ctlptl):\n\n```shell\n$ ctlptl apply -f cluster.yaml\n```\n\nThe `cluster.yaml` configuration creates a kind cluster with a Docker registry\non localhost port 5005. This allows for the publishing of a Docker image for the\nexample release locally in a place the kind cluster can pull from:\n\n```shell\n$ docker build -f Dockerfile.ip -t localhost:5005/k8s_erlang_cluster:ip-0.1.0\n$ docker push -f Dockerfile.ip localhost:5005/k8s_erlang_cluster:ip-0.1.0\n```\n\nThe [kustomize](https://kustomize.io/) configuration can be used to install the\nrelease with `kubectl apply -k`:\n\n```shell\n$ kubectl apply -k deployment/base\nnamespace/k8s-erlang-cluster created\nconfigmap/k8s-erlang-cluster created\nservice/k8s-erlang-cluster created\ndeployment.apps/k8s-erlang-cluster created\n```\n\nWith `get endpoints` we can view the results of the creation of a headless\nService that matches 3 Pods:\n\n```shell\n$ kubectl -n k8s-erlang-cluster get endpoints k8s-erlang-cluster\nNAME                 ENDPOINTS                                            AGE\nk8s-erlang-cluster   10.244.0.5:39135,10.244.0.6:39135,10.244.0.7:39135   7m11s\n```\n\nTo see that the cluster is formed run a command against a single Pod in the\nDeployment with `exec`:\n\n```shell\n$ kubectl exec -n k8s-erlang-cluster deploy/k8s-erlang-cluster -- bin/k8s_erlang_cluster eval 'nodes().'\n['k8s_erlang_cluster@10.244.0.5', 'k8s_erlang_cluster@10.244.0.7']\n```","ref":"kubernetes_example.md.html#run"},{"type":"extras","title":"SRV - Kubernetes Examples","doc":"This section builds on the previous section on using [IPs](#ips) for the host\nname part of a node name and DNS queries for A records. The necessary changes to\nthe Kubernetes deployment are done in a kustomize overlay,\n`deployment/overlays/srv`.\n\nThe SRV specific build is done with the `rebar3` profile `srv_prod` and a\nseparate Dockerfile `Dockerfile.srv`. It also includes a necessary change to the\nCoreDNS ConfigMap in the Kubernetes cluster.","ref":"kubernetes_example.md.html#srv"},{"type":"extras","title":"Setup - Kubernetes Examples","doc":"To us `SRV` records we set `record_type` to `srv` in the `gen_cluster`\nconfiguration. A separate `sys.config` file is used by the `rebar3` profile\nnamed `srv_sys.config`:\n\n```erlang\n[{discovery, {dns, #{record_type => srv,\n                     domain => \"_dist-erl._tcp.k8s-erlang-cluster.k8s-erlang-cluster\"}}}]},\n```\n\nThis tells `gen_cluster` to use the DNS module for finding peers by looking up\nthe `SRV` records and using the results as the host part of each node name.  The\n`domain` is set to `_ ._ . . ` which\nresolves to records for the service `k8s-erlang-cluster` in a namespace\n`k8s-erlang-cluster` for the port named `dist-erl` and using protocol `TCP`.\nThis is setup in the `base/service.yaml` the same as is used for the `IP`\nversion of discovery above, but made use of here:\n\n```yaml\nkind: Service\napiVersion: v1\nmetadata:\n  name: k8s-erlang-cluster\nspec:\n  clusterIP: None\n  ports:\n  - protocol: TCP\n    port: 39135\n    targetPort: dist-erl\n    name: dist-erl\n```\n\nA separate `vm.args` is used because we want to set no host part of the node\nname after `-name`:\n\n```shell\n-name k8s_erlang_cluster\n```\n\nThis way Erlang essentially uses the result of the command `hostname --fqdn`. By\ndefault in Kubernetes this will not include any Service subdomain and the FQDN\nwill be the same as the short name. So `subdoman` must be added to the\nPod spec of the Deployment resource:\n\n```yaml\nsubdomain: \"k8s-erlang-cluster\"\n```\n\nThis is done in a kustomize patch file added to\n`deployment/overlays/srv/kustomization.yaml`:\n\n```yaml\npatches:\n- path: deployment.yaml\n```\n\nNow `hostname --fqdn` on the container in the Pod would result in ` .k8s-erlang-cluster.svc.cluster.local`\n\nNothing is changed in the `env` of `deployment.yaml` but the only part used in\nthis container is the `ERL_DIST_PORT`:\n\n```yaml\nenv:\n- name: ERL_DIST_PORT\n  value: \"39135\"\n```\n\nWhile the same [headless\nservice](https://kubernetes.io/docs/concepts/services-networking/service/#headless-services)\nis used to expose the IPs of these Pods through DNS, by default the DNS records\nfor a `SRV` query would look like:\n\n```\n_dist-erl._tcp.k8s-erlang-cluster.k8s-erlang-cluster.svc.cluster.local  service\n= 0 33 39135 10-244-0-15.k8s-erlang-cluster.k8s-erlang-cluster.svc.cluster.local.\n```\n\nNotice the `10-244-0-15` part of the name. This is the IP of the corresponding\nPod. Using the Pod name instead of the IP with A records or the IP based domain\ncould be more useful in logs and other telemetry about a node. Also note that,\nas far as I've ever found, there is no way to actually get the IP based name\neasily into an environment variable to use as a name in the Erlang node name.\n\nIn order for DNS to use the name of the Pod we can add an option to the\nconfiguration of CoreDNS through its ConfigMap:\n\n```\n$ kubectl -n kube-system edit configmap coredns\n...\nkubernetes cluster.local in-addr.arpa ip6.arpa {\n    pods insecure\n    fallthrough in-addr.arpa ip6.arpa\n    ttl 30\n    endpoint_pod_names\n}\n...\n$ kubectl -n kube-system rollout restart deployment coredns\n```\n\nThis will restart the Pods in the CoreDNS Deployment and pickup the modified\nConfigMap with `endpoint_pod_names` set.\n\nIn the example a ConfigMap resource is provided\n(`deployments/overlays/srv/coredns-configmap.yaml`) and applied with `kubectl`,\nbut for CoreDNS to pickup the configuration change the deployment must still be\nrestarted:\n\n```shell\n$ kubectl -n kube-system rollout restart deployment coredns\n```\n\nI first learned about this CoreDNS option from the blog posts [K8s Erlang\nClustering](https://lrascao.github.io/k8s-erlang-clustering/) by [Luis\nRascão](https://github.com/lrascao) and [CoreDNS:\n`endpoint_pod_names`](https://blog.differentpla.net/blog/2022/01/08/coredns-endpoint-pod-names/)\nby [Roger Lipscombe](http://rogerlipscombe.me/).","ref":"kubernetes_example.md.html#setup"},{"type":"extras","title":"Run - Kubernetes Examples","doc":"The example can be installed to any Kubernetes cluster but comes with a\nconfiguration (`examples/k8s_erlang_cluster/cluster.yaml`) for creating the\ncluster with [kind](https://kind.sigs.k8s.io/) via the tool\n[ctlptl](https://github.com/tilt-dev/ctlptl):\n\n```shell\n$ ctlptl apply -f cluster.yaml\n```\n\nThe `cluster.yaml` configuration creates a kind cluster with a Docker registry\non localhost port 5005. This allows for the publishing of a Docker image for the\nexample release locally in a place the kind cluster can pull from:\n\n```shell\n$ docker build -f Dockerfile.srv -t localhost:5005/k8s_erlang_cluster:srv-0.1.0\n$ docker push -f Dockerfile.srv localhost:5005/k8s_erlang_cluster:srv-0.1.0\n```\n\nThe [kustomize](https://kustomize.io/) `srv` overlay is used to install the\nrelease with `kubectl apply -k`:\n\n```shell\n$ kubectl apply -k deployment/overlays/srv\nnamespace/k8s-erlang-cluster created\nWarning: resource configmaps/coredns is missing the kubectl.kubernetes.io/last-applied-configuration annotation which is required by kubectl apply. kubectl apply should only be used on resources created declaratively by either kubectl create --save-config or kubectl apply. The missing annotation will be patched automatically.\nconfigmap/coredns configured\nservice/k8s-erlang-cluster created\ndeployment.apps/k8s-erlang-cluster created\n```\n\nCoreDNS must now be manually restarted to pickup the new configuration:\n\n```shell\n$ kubectl rollout restart -n kube-system deployment coredns\n```\n\nIt may take a few seconds for the cluster to form because we had to restart DNS\nand wait for a `gen_cluster` refresh. To see that the cluster has formed and the\nhost part of the node name is an FQDN of ` . . .svc.cluster.local` run a command against a single\nPod in the Deployment with `exec`:\n\n```shell\n$ kubectl exec -n k8s-erlang-cluster deploy/k8s-erlang-cluster -- bin/k8s_erlang_cluster eval 'nodes().'\n['k8s_erlang_cluster@k8s-erlang-cluster-5f4954c6b5-kzcwl.k8s-erlang-cluster.k8s-erlang-cluster.svc.cluster.local', 'k8s_erlang_cluster@k8s-erlang-cluster-5f4954c6b5-6ts2w.k8s-erlang-cluster.k8s-erlang-cluster.svc.cluster.local']\n```","ref":"kubernetes_example.md.html#run"},{"type":"extras","title":"StatefulSet - Kubernetes Examples","doc":"Another option for host names that work with SRV records is a\n[StatefulSet](https://kubernetes.io/docs/concepts/workloads/controllers/statefulset/).\nThese provide a stable host name for each Pod ` - `.\nThe same steps in the [SRV](#setup-srv) section will work to configure the release and\ndiscovery with the key difference that no configuration changes to CoreDNS are\nnecessary for this to work.\n\nBut there are limitations to use of a StatefulSet and they should only be used\nwhere you truly need the stable network name or persistent storage. See the\nKubernetes docs for more on\n[StatefulSets](https://kubernetes.io/docs/concepts/workloads/controllers/statefulset/).","ref":"kubernetes_example.md.html#statefulset"}],"content_type":"text/plain","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}